﻿using System;
using System.Text;
using System.Windows.Forms;

namespace Gerando_Senhas
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        int TamanhoDaSenha = 8;

        private void btnGerarSenha1_Click(object sender, EventArgs e)
        {
            ValidaTamanhoSenha();
            string validar = "abcdefghijklmnozABCDEFGHIJKLMNOZ1234567890@#$%&*!";
            try
            {
                StringBuilder strbld = new StringBuilder(100);
                Random random = new Random();
                while (0 < TamanhoDaSenha--)
                {
                    strbld.Append(validar[random.Next(validar.Length)]);
                }
                txtSenha.Text = strbld.ToString();
            }
            catch(Exception ex)
            {
                MessageBox.Show("Erro : " + ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

       

        private void btnGerarSenha2_Click(object sender, EventArgs e)
        {
            ValidaTamanhoSenha();
            string codigoSenha = DateTime.Now.Ticks.ToString();
            try
            {
                string senha = BitConverter.ToString(new System.Security.Cryptography.SHA512CryptoServiceProvider().ComputeHash(Encoding.Default.GetBytes(codigoSenha))).Replace("-", String.Empty);
                txtSenha.Text = senha.Substring(0, TamanhoDaSenha);
            }
            catch(Exception ex)
            {
                MessageBox.Show("Erro : " + ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnGerarSenha3_Click(object sender, EventArgs e)
        {
            try
            {
                ValidaTamanhoSenha();
                string guid = Guid.NewGuid().ToString().Replace("-", "");
                if (guid.Length > TamanhoDaSenha)
                {
                    txtSenha.Text = guid.Substring(0, TamanhoDaSenha);
                }
                else
                {
                    txtSenha.Text = guid;
                    txtTamanhoSenha.Text = guid.Length.ToString();
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show("Erro : " + ex.Message, "Erro", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnGerarSenha4_Click(object sender, EventArgs e)
        {
            ValidaTamanhoSenha();

            string caracteresPermitidos = "abcdefghijkmnopqrstuvwxyzABCDEFGHJKLMNOPQRSTUVWXYZ0123456789!@$?_-";
            char[] chars = new char[TamanhoDaSenha];

            Random rd = new Random();

            for (int i = 0; i < TamanhoDaSenha; i++)
            {
                chars[i] = caracteresPermitidos[rd.Next(0, caracteresPermitidos.Length)];
            }

            txtSenha.Text = new string(chars);
        }

        //==========================================================================================
        //valida o tamanho da senha
        private void ValidaTamanhoSenha()
        {
            if (!string.IsNullOrWhiteSpace(txtTamanhoSenha.Text))
            {
                TamanhoDaSenha = Convert.ToInt32(txtTamanhoSenha.Text);

                if (TamanhoDaSenha > 99)
                {
                    TamanhoDaSenha = 99;
                    txtTamanhoSenha.Text = "99";
                }
                if (TamanhoDaSenha < 8)
                {
                    TamanhoDaSenha = 8;
                    txtTamanhoSenha.Text = "8";
                }
            }
            else
            {
                txtTamanhoSenha.Text = "8";
            }
        }

        //Permite somente valores números no TextBox
        private void txtTamanhoSenha_KeyPress(object sender, KeyPressEventArgs e)
        {
            e.Handled = (!char.IsDigit(e.KeyChar)) && (!char.IsControl(e.KeyChar));
        }
    }
}
